_, BrokerGarbage_LootManager = ...

BrokerGarbage:CheckSettings()
BrokerGarbage_LootManager:CheckSettings()

BrokerGarbage.LootManagerOptions = CreateFrame("Frame", "BrokerGarbageOptionsFrame", InterfaceOptionsFramePanelContainer)
BrokerGarbage.LootManagerOptions.name = BrokerGarbage_LootManager.locale.LMTitle
BrokerGarbage.LootManagerOptions.parent = "Broker_Garbage"
BrokerGarbage.LootManagerOptions:Hide()

local function Update(self)
	BrokerGarbage:LootManagerOptionsUpdate(self)
end

local function ShowOptions(frame)
	local title = LibStub("tekKonfig-Heading").new(BrokerGarbage.LootManagerOptions, "Broker_Garbage - " .. BrokerGarbage_LootManager.locale.LMTitle)
	
	local subtitle = BrokerGarbage.LootManagerOptions:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	subtitle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
	subtitle:SetPoint("RIGHT", BrokerGarbage.LootManagerOptions, -32, 0)
	subtitle:SetHeight(45)
	subtitle:SetNonSpaceWrap(true)
	subtitle:SetJustifyH("LEFT")
	subtitle:SetJustifyV("TOP")
	subtitle:SetText(BrokerGarbage_LootManager.locale.LMSubTitle)
	
	local enable = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMEnableTitle, "TOPLEFT", subtitle, "BOTTOMLEFT", -2, -4)
	enable.tiptext = BrokerGarbage_LootManager.locale.LMEnableTooltip
	enable:SetChecked(BGLM_GlobalDB.useLootManager)
	local checksound = enable:GetScript("OnClick")
	enable:SetScript("OnClick", function(enable)
		checksound(enable)
		BGLM_GlobalDB.useLootManager = not BGLM_GlobalDB.useLootManager
		Update()
	end)
	
	-- -- Selective Looting -------------------------------------------------------
	local selective = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMSelectiveTitle, "TOPLEFT", enable, "BOTTOMLEFT", 14, -20)
	selective.tiptext = BrokerGarbage_LootManager.locale.LMSelectiveTooltip
	selective:SetChecked(BGLM_LocalDB.selectiveLooting)
	selective:SetScript("OnClick", function(selective)
		checksound(selective)
		BGLM_LocalDB.selectiveLooting = not BGLM_LocalDB.selectiveLooting
		Update()
	end)
	
	
	local autoLoot = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMAutoLootTitle, "TOPLEFT", selective, "BOTTOMLEFT", 14, 0)
	autoLoot.tiptext = BrokerGarbage_LootManager.locale.LMAutoLootTooltip
	autoLoot:SetChecked(BGLM_GlobalDB.autoLoot)
	autoLoot:SetScript("OnClick", function(autoLoot)
		checksound(autoLoot)
		BGLM_GlobalDB.autoLoot = not BGLM_GlobalDB.autoLoot
		Update()
	end)
	
	local autoLoot_skinning = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMAutoLootSkinningTitle, "TOPLEFT", autoLoot, "BOTTOMLEFT", 14, 0)
	autoLoot_skinning.tiptext = BrokerGarbage_LootManager.locale.LMAutoLootSkinningTooltip
	autoLoot_skinning:SetChecked(BGLM_GlobalDB.autoLootSkinning)
	autoLoot_skinning:SetScript("OnClick", function(autoLoot_skinning)
		checksound(autoLoot_skinning)
		BGLM_GlobalDB.autoLootSkinning = not BGLM_GlobalDB.autoLootSkinning
	end)
	
	local autoLoot_pickpocket = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMAutoLootPickpocketTitle, "TOPLEFT", autoLoot_skinning, "BOTTOMLEFT", 0, 0)
	autoLoot_pickpocket.tiptext = BrokerGarbage_LootManager.locale.LMAutoLootPickpocketTooltip
	autoLoot_pickpocket:SetChecked(BGLM_GlobalDB.autoLootPickpocket)
	autoLoot_pickpocket:SetScript("OnClick", function(autoLoot_pickpocket)
		checksound(autoLoot_pickpocket)
		BGLM_GlobalDB.autoLootPickpocket = not BGLM_GlobalDB.autoLootPickpocket
	end)
	
	local autoLoot_fishing = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMAutoLootFishingTitle, "TOPLEFT", autoLoot_pickpocket, "BOTTOMLEFT", 0, 0)
	autoLoot_fishing.tiptext = BrokerGarbage_LootManager.locale.LMAutoLootFishingTooltip
	autoLoot_fishing:SetChecked(BGLM_GlobalDB.autoLootPickpocket)
	autoLoot_fishing:SetScript("OnClick", function(autoLoot_fishing)
		checksound(autoLoot_fishing)
		BGLM_GlobalDB.autoLootFishing = not BGLM_GlobalDB.autoLootFishing
	end)
	
	
	local autoDestroy = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMAutoDestroyTitle, "TOPLEFT", autoLoot_fishing, "BOTTOMLEFT", -14, 0)
	autoDestroy.tiptext = BrokerGarbage_LootManager.locale.LMAutoDestroyTooltip
	autoDestroy:SetChecked(BGLM_GlobalDB.autoDestroy)
	autoDestroy:SetScript("OnClick", function(autoDestroy)
		checksound(autoDestroy)
		BGLM_GlobalDB.autoDestroy = not BGLM_GlobalDB.autoDestroy
		Update()
	end)
	
	local autoDestroyInstant = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMAutoDestroyInstantTitle, "TOPLEFT", autoDestroy, "BOTTOMLEFT", 14, 0)
	autoDestroyInstant.tiptext = BrokerGarbage_LootManager.locale.LMAutoDestroyInstantTooltip
	autoDestroyInstant:SetChecked(BGLM_GlobalDB.autoDestroyInstant)
	autoDestroyInstant:SetScript("OnClick", function(autoDestroyInstant)
		checksound(autoDestroyInstant)
		BGLM_GlobalDB.autoDestroyInstant = not BGLM_GlobalDB.autoDestroyInstant
		Update()
	end)
	
	local minFreeSlots = LibStub("tekKonfig-Slider").new(BrokerGarbage.LootManagerOptions, BrokerGarbage_LootManager.locale.LMFreeSlotsTitle, 0, 30, "TOPLEFT", autoDestroyInstant, "BOTTOMLEFT", 0, -20)
	minFreeSlots.tiptext = BrokerGarbage_LootManager.locale.LMFreeSlotsTooltip
	minFreeSlots:SetWidth(200)
	minFreeSlots:SetValueStep(1)
	minFreeSlots:SetValue(BGLM_GlobalDB.tooFewSlots)
	minFreeSlots.text = minFreeSlots:CreateFontString("$parentCenterText", "ARTWORK", "GameFontHighlightSmall")
	minFreeSlots.text:SetPoint("TOP", minFreeSlots, "BOTTOM", 0, 3)
	minFreeSlots.text:SetText(BGLM_GlobalDB.tooFewSlots)
	minFreeSlots:SetScript("OnValueChanged", function(minFreeSlots)
		BGLM_GlobalDB.tooFewSlots = minFreeSlots:GetValue()
		minFreeSlots.text:SetText(BGLM_GlobalDB.tooFewSlots)
		BrokerGarbage:ScanInventory()
	end)
	
	
	-- -- Restack -----------------------------------------------------------------
	local restack = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMRestackTitle, "TOPLEFT", selective, "TOPLEFT", 200, 0)
	restack.tiptext = BrokerGarbage_LootManager.locale.LMRestackTooltip
	restack:SetChecked(BGLM_GlobalDB.restackIfNeeded)
	restack:SetScript("OnClick", function(restack)
		checksound(restack)
		BGLM_GlobalDB.restackIfNeeded = not BGLM_GlobalDB.restackIfNeeded
		Update()
	end)
	
	local fullRestack = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMFullRestackTitle, "TOPLEFT", restack, "BOTTOMLEFT", 14, 0)
	fullRestack.tiptext = BrokerGarbage_LootManager.locale.LMFullRestackTooltip
	fullRestack:SetChecked(BGLM_GlobalDB.restackFullInventory)
	fullRestack:SetScript("OnClick", function(fullRestack)
		checksound(fullRestack)
		BGLM_GlobalDB.restackFullInventory = not BGLM_GlobalDB.restackFullInventory
	end)
	
	-- -- Opening Items -----------------------------------------------------------
	local openContainers = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMOpenContainersTitle, "TOPLEFT", fullRestack, "BOTTOMLEFT", -14, 0)
	openContainers.tiptext = BrokerGarbage_LootManager.locale.LMOpenContainersTooltip
	openContainers:SetChecked(BGLM_GlobalDB.openContainers)
	openContainers:SetScript("OnClick", function(openContainers)
		checksound(openContainers)
		BGLM_GlobalDB.openContainers = not BGLM_GlobalDB.openContainers
	end)
	
	local openClams = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMOpenClamsTitle, "TOPLEFT", openContainers, "BOTTOMLEFT", 0, 0)
	openClams.tiptext = BrokerGarbage_LootManager.locale.LMOpenClamsTooltip
	openClams:SetChecked(BGLM_GlobalDB.openClams)
	openClams:SetScript("OnClick", function(openClams)
		checksound(openClams)
		BGLM_GlobalDB.openClams = not BGLM_GlobalDB.openClams
	end)
	
	local warnLM = LibStub("tekKonfig-Checkbox").new(BrokerGarbage.LootManagerOptions, nil, BrokerGarbage_LootManager.locale.LMWarnLMTitle, "TOPLEFT", openClams, "BOTTOMLEFT", 0, 0)
	warnLM.tiptext = BrokerGarbage_LootManager.locale.LMWarnLMTooltip
	warnLM:SetChecked(BGLM_GlobalDB.warnLM)
	warnLM:SetScript("OnClick", function(warnLM)
		checksound(warnLM)
		BGLM_GlobalDB.warnLM = not BGLM_GlobalDB.warnLM
	end)
	
	-- -- Loot Treshold -----------------------------------------------------------
	local editbox = CreateFrame("EditBox", nil, BrokerGarbage.LootManagerOptions)
	editbox:SetAutoFocus(false)
	editbox:SetWidth(100); editbox:SetHeight(32)
	editbox:SetFontObject("GameFontHighlightSmall")
	editbox:SetText(BrokerGarbage:FormatMoney(BGLM_LocalDB.itemMinValue))
	local left = editbox:CreateTexture(nil, "BACKGROUND")
	left:SetWidth(8) left:SetHeight(20)
	left:SetPoint("LEFT", -5, 0)
	left:SetTexture("Interface\\Common\\Common-Input-Border")
	left:SetTexCoord(0, 0.0625, 0, 0.625)
	local right = editbox:CreateTexture(nil, "BACKGROUND")
	right:SetWidth(8) right:SetHeight(20)
	right:SetPoint("RIGHT", 0, 0)
	right:SetTexture("Interface\\Common\\Common-Input-Border")
	right:SetTexCoord(0.9375, 1, 0, 0.625)
	local center = editbox:CreateTexture(nil, "BACKGROUND")
	center:SetHeight(20)
	center:SetPoint("RIGHT", right, "LEFT", 0, 0)
	center:SetPoint("LEFT", left, "RIGHT", 0, 0)
	center:SetTexture("Interface\\Common\\Common-Input-Border")
	center:SetTexCoord(0.0625, 0.9375, 0, 0.625)

	local minvalue = editbox:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	minvalue:SetPoint("TOPLEFT", warnLM, "BOTTOMLEFT", 0, -20)
	minvalue:SetText(BrokerGarbage_LootManager.locale.LMItemMinValue)
	editbox:SetPoint("TOP", minvalue, "BOTTOM", 0, 0)
	local function ResetEditBox(self)
		self:SetText(BrokerGarbage:FormatMoney(BGLM_LocalDB.itemMinValue))
		self:ClearFocus()
	end
	local function UnFormatEditBox(self)
		self:SetText(BGLM_LocalDB.itemMinValue)
	end
	local function SubmitEditBox()
		BGLM_LocalDB.itemMinValue = tonumber(editbox:GetText())
		editbox:SetText(BrokerGarbage:FormatMoney(BGLM_LocalDB.itemMinValue))
		editbox:ClearFocus()
	end
	editbox:SetScript("OnEscapePressed", ResetEditBox)
	editbox:SetScript("OnEnterPressed", SubmitEditBox)
	editbox:SetScript("OnEditFocusGained", UnFormatEditBox)
	
	
	function BrokerGarbage.LootManagerOptionsUpdate(self)
		if BGLM_GlobalDB.useLootManager then
			restack:Enable()
			if BGLM_GlobalDB.restackIfNeeded then
				fullRestack:Enable()
			else
				fullRestack:Disable()
			end
			
			openContainers:Enable()
			openClams:Enable()
			warnLM:Enable()
			
			selective:Enable()
			if BGLM_LocalDB.selectiveLooting then
				autoLoot:Enable()
				autoDestroy:Enable()
				
				if not BGLM_GlobalDB.autoLoot then
					autoLoot_skinning:Enable()
					autoLoot_pickpocket:Enable()
					autoLoot_fishing:Enable()
				else
					autoLoot_skinning:Disable()
					autoLoot_pickpocket:Disable()
					autoLoot_fishing:Disable()
				end
				
				if BGLM_GlobalDB.autoDestroy then
					minFreeSlots:Enable()
					autoDestroyInstant:Enable()
				else
					minFreeSlots:Disable()
					autoDestroyInstant:Disable()
				end
			else
				autoLoot:Disable()
				autoDestroy:Disable()
				autoDestroyInstant:Disable()
				autoLoot_skinning:Disable()
				autoLoot_pickpocket:Disable()
				autoLoot_fishing:Disable()
				minFreeSlots:Disable()
			end
			
		else
			restack:Disable()
				fullRestack:Disable()
			
			openContainers:Disable()
			openClams:Disable()
			warnLM:Disable()
			
			selective:Disable()
				autoLoot:Disable()
					autoLoot_skinning:Disable()
					autoLoot_pickpocket:Disable()
					autoLoot_fishing:Disable()
				autoDestroy:Disable()
					minFreeSlots:Disable()
					autoDestroyInstant:Disable()
			
		end
	end
	
	BrokerGarbage:LootManagerOptionsUpdate()
	BrokerGarbage.LootManagerOptions:SetScript("OnShow", BrokerGarbage.LootManagerOptionsUpdate)
end

table.insert(BrokerGarbage.optionsModules, 3, BrokerGarbage.LootManagerOptions)
BrokerGarbage.optionsModules[3].OnShow = ShowOptions
--BrokerGarbage.LootManagerOptions:SetScript("OnShow", ShowOptions)